VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.1#0"; "richtx32.ocx"
Begin VB.Form frmEdit
   Caption         =   "Standard Edit Support"
   ClientHeight    =   2970
   ClientLeft      =   1095
   ClientTop       =   1800
   ClientWidth     =   6300
   Icon            =   "FEditMenu.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   2970
   ScaleWidth      =   6300
   Begin RichTextLib.RichTextBox RichTextBox1
      Height          =   1095
      Left            =   270
      TabIndex        =   1
      Top             =   1560
      Width           =   5595
      _ExtentX        =   9869
      _ExtentY        =   1931
      _Version        =   327681
      Enabled         =   -1  'True
      ScrollBars      =   3
      AutoVerbMenu    =   -1  'True
      TextRTF         =   $"FEditMenu.frx":0442
   End
   Begin VB.TextBox Text1
      Height          =   1095
      Left            =   270
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   240
      Width           =   5595
   End
   Begin VB.Menu mMain
      Caption         =   "&Demo"
      Index           =   0
      Begin VB.Menu mControl
         Caption         =   "&Textbox"
         Index           =   0
         Shortcut        =   ^T
      End
      Begin VB.Menu mControl
         Caption         =   "&RichTextBox"
         Index           =   1
         Shortcut        =   ^R
      End
      Begin VB.Menu mBar0
         Caption         =   "-"
      End
      Begin VB.Menu mLoad
         Caption         =   "&Load AUTOEXEC"
      End
      Begin VB.Menu mBar1
         Caption         =   "-"
      End
      Begin VB.Menu mExit
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mMain
      Caption         =   "&Edit"
      Index           =   1
      Begin VB.Menu mEdit
         Caption         =   "&Undo"
         Index           =   0
         Shortcut        =   ^Z
      End
      Begin VB.Menu mEdit
         Caption         =   "-"
         Index           =   1
      End
      Begin VB.Menu mEdit
         Caption         =   "Cu&t"
         Index           =   2
         Shortcut        =   ^X
      End
      Begin VB.Menu mEdit
         Caption         =   "&Copy"
         Index           =   3
         Shortcut        =   ^C
      End
      Begin VB.Menu mEdit
         Caption         =   "&Paste"
         Index           =   4
         Shortcut        =   ^V
      End
      Begin VB.Menu mEdit
         Caption         =   "&Delete"
         Index           =   5
         Shortcut        =   {DEL}
      End
   End
   Begin VB.Menu mMain
      Caption         =   "&Format"
      Index           =   2
      Begin VB.Menu mFormat
         Caption         =   "&Normal"
         Index           =   0
      End
      Begin VB.Menu mFormat
         Caption         =   "&Bold"
         Index           =   1
      End
      Begin VB.Menu mFormat
         Caption         =   "&Italic"
         Index           =   2
      End
      Begin VB.Menu mFormat
         Caption         =   "B&old-Italic"
         Index           =   3
      End
   End
End
Attribute VB_Name = "frmEdit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

' *********************************************************************
'  Copyright 1997 Karl E. Peterson, All Rights Reserved
' *********************************************************************
'  You are free to use this code within your own applications, but you
'  are expressly forbidden from selling or otherwise distributing this
'  source code without prior written consent.
' *********************************************************************
Option Explicit
'
' Windows API call used to control textbox
'
#If Win16 Then
   Private Declare Function SendMessage Lib "User" (ByVal hWnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, lParam As Any) As Long
#ElseIf Win32 Then
   Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
#End If
'
' Edit Control Messages
'
Const WM_CUT = &H300
Const WM_COPY = &H301
Const WM_PASTE = &H302
Const WM_CLEAR = &H303
Const WM_UNDO = &H304
#If Win16 Then
   Const EM_CANUNDO = &H416     'WM_USER + 22
   Const EM_GETMODIFY = &H408   'WM_USER + 8
#ElseIf Win32 Then
   Const EM_CANUNDO = &HC6
   Const EM_GETMODIFY = &HB8
#End If
'
' Edit menu array constants
'
Const mUndo = 0
Const mCut = 2
Const mCopy = 3
Const mPaste = 4
Const mDelete = 5
'
' Flag to track status of Control key
'
Private m_ControlKey As Boolean

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
   '
   ' Watch for Control key, set flag
   '
   If KeyCode = vbKeyControl Then
      m_ControlKey = True
   End If
End Sub

Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
   '
   ' Watch for Control key, clear flag
   '
   If KeyCode = vbKeyControl Then
      m_ControlKey = False
   End If
End Sub

Private Sub Form_Load()
   '
   ' Load some data and show the RichTextBox
   '
   mLoad_Click
   mControl_Click 1
End Sub

Private Sub Form_Resize()
   '
   ' Size edit area to fit form
   '
   Text1.Move 0, 0, Me.ScaleWidth, Me.ScaleHeight
   RichTextBox1.Move 0, 0, Me.ScaleWidth, Me.ScaleHeight
End Sub

Private Sub mControl_Click(Index As Integer)
   Const ctlText = 0
   Const ctlRichText = 1
   '
   ' Toggle between the two edit controls
   '
   Select Case Index
      Case ctlText
         Text1.Visible = True
         RichTextBox1.Visible = False
         Me.Caption = "Standard Edit Support: TextBox"
         mControl(ctlText).Checked = True
         mControl(ctlRichText).Checked = False
         mMain(2).Enabled = False
      Case ctlRichText
         RichTextBox1.Visible = True
         Text1.Visible = False
         Me.Caption = "Standard Edit Support: RichTextBox"
         mControl(ctlText).Checked = False
         mControl(ctlRichText).Checked = True
         mMain(2).Enabled = True
   End Select
End Sub

Private Sub mEdit_Click(Index As Integer)
   '
   ' Call generic routine to perform requested action.
   ' Same routine could be called from a toolbar event.
   '
   Select Case Index
      Case mUndo
         EditPerform WM_UNDO
      Case mCut
         EditPerform WM_CUT
      Case mCopy
         EditPerform WM_COPY
      Case mPaste
         EditPerform WM_PASTE
      Case mDelete
         EditPerform WM_CLEAR
   End Select
End Sub

Private Sub mExit_Click()
   Unload Me
End Sub

Private Sub mFormat_Click(Index As Integer)
   Const mNormal = 0
   Const mBold = 1
   Const mItalic = 2
   Const mBoldItalic = 3
   '
   ' Format highlighted text appropriately
   '
   With RichTextBox1
      Select Case Index
         Case mNormal
            .SelBold = False
            .SelItalic = False
         Case mBold
            .SelBold = True
            .SelItalic = False
         Case mItalic
            .SelBold = False
            .SelItalic = True
         Case mBoldItalic
            .SelBold = True
            .SelItalic = True
      End Select
   End With
End Sub

Private Sub mLoad_Click()
   Dim Proceed As Integer
   '
   ' See if user has changed the text, and if so
   ' prompt before loading new copy.
   '
   Proceed = vbYes
   If SendMessage(Text1.hWnd, EM_GETMODIFY, 0, 0&) Then
      Proceed = MsgBox("Text has been modified" _
                       & Chr$(13) & "Continue?", _
                       vbYesNo, "Warning")
   End If
   If Proceed = vbYes Then
      '
      ' Load AUTOEXEC.BAT (if exists) into textbox
      '
      On Error Resume Next
         Open "c:\autoexec.bat" For Binary As #1
         Text1.Text = Input(LOF(1), 1)
         RichTextBox1.Text = Text1.Text
         Close #1
      On Error GoTo 0
   End If
End Sub

Private Sub mMain_Click(Index As Integer)
   Const mDemo = 0
   Const mEdit = 1
   Const mFormat = 2
   '
   ' If Edit menu is dropped down, set available choices
   '
   If Index = mEdit Then
      EditMenuToggle
   End If
End Sub

Private Sub EditMenuToggle()
   If TypeOf Me.ActiveControl Is TextBox Or _
      TypeOf Me.ActiveControl Is RichTextBox Then
      '
      ' Determine if last edit can be undone
      '
      Me.mEdit(mUndo).Enabled = SendMessage(Me.ActiveControl.hWnd, EM_CANUNDO, 0, 0&)
      '
      ' See if there's anything to cut, copy, or delete
      '
      Me.mEdit(mCut).Enabled = Me.ActiveControl.SelLength
      Me.mEdit(mCopy).Enabled = Me.ActiveControl.SelLength
      Me.mEdit(mDelete).Enabled = Me.ActiveControl.SelLength
      '
      ' See if there's anything to paste
      '
      Me.mEdit(mPaste) = Clipboard.GetFormat(vbCFText)
   Else
      '
      ' If active control is not a textbox then disable all
      '
      Me.mEdit(mUndo).Enabled = False
      Me.mEdit(mCut).Enabled = False
      Me.mEdit(mCopy).Enabled = False
      Me.mEdit(mPaste).Enabled = False
      Me.mEdit(mDelete).Enabled = False
   End If
End Sub

Private Sub EditPerform(EditFunction As Integer)
   '
   ' A "wrapper" function for SendMessage
   ' Requests function passed in EditFunction
   ' Beeps if active control is not a textbox
   '
   If TypeOf Me.ActiveControl Is TextBox Then
      Call SendMessage(Me.ActiveControl.hWnd, EditFunction, 0, 0&)
   ElseIf TypeOf Me.ActiveControl Is RichTextBox Then
      If m_ControlKey = False Then
         Call SendMessage(Me.ActiveControl.hWnd, EditFunction, 0, 0&)
      End If
   Else
      Beep
   End If
End Sub

